#!/bin/bash
# ----------------------------------------------------------------------------
# /var/install/config.d/cui-quassel-core - QUASSEL_CORE configuration
#
# Creation   : 2009-12-14 Marcel Weiler
#
# Copyright (c) 2001-2013 The eisfair Team, <team(at)eisfair(dot)org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# ----------------------------------------------------------------------------

#exec 2> /tmp/cui-quassel-core-trace$$.log
#set -x

packageName=cui-quassel-core
packageNameBinary=quasselcore

# ----------------------------------------------------------------------------
# Includes
# ----------------------------------------------------------------------------

# include eislib
. /var/install/include/eislib

# include config
. /etc/conf.d/${packageName}


# ----------------------------------------------------------------------
# Functions
# ----------------------------------------------------------------------
_edit_logrotate_file()
{
    creationTime=`date -Iseconds`

    {
        echo '# ----------------------------------------------------------------------------'
        echo "# /etc/logrotate.d/${packageNameBinary} created by ${0}"
        echo '#'
        echo '# DO NOT EDIT THIS FILE BY HAND! (use eisfair setup!)'
        echo '#'
        echo "# Created: ${creationTime}"
        echo '# ----------------------------------------------------------------------------'
        echo "$QUASSEL_CORE_LOG_FILE {"
    } > /etc/logrotate.d/${packageNameBinary}

    cat >> /etc/logrotate.d/${packageNameBinary} <<-EOFG
    rotate ${QUASSEL_CORE_LOG_COUNT}
    ${QUASSEL_CORE_LOG_INTERVAL}
    compress
    delaycompress
    copytruncate
    missingok
    notifempty
    }
EOFG

    chmod 0600 /etc/logrotate.d/${packageNameBinary}
    chown root /etc/logrotate.d/${packageNameBinary}
}



# ----------------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------------

# Change logrotate file to actual config settings
_edit_logrotate_file

# restart if START_QUASSEL_CORE='yes'
if [ "${START_QUASSEL_CORE}" = 'yes' ] ; then
    /etc/init.d/${packageNameBinary} restart
fi

exit 0
# ----------------------------------------------------------------------------
# End
# ----------------------------------------------------------------------------
