#!/bin/sh
#------------------------------------------------------------------------------
# /var/install/config.d/menu.sh - menu configuration script
# Copyright (c) 2001-2013 the eisfair team, team(at)eisfair(dot)org
#------------------------------------------------------------------------------
. /var/install/include/configlib
. /etc/config.d/menu

# write new config file
{
    echo "#--------------------------------------------------------------------"
    echo "# Menu configuration file generated by /var/install/config.d/menu.sh"
    echo "#"
    echo "# Contains:"
    echo "#  - color definitions for show-menu.cui, show-doc.cui and edit-conf.cui"
    echo "#"
    echo "# Do not edit this file by hand"
    echo "#"
    echo "#"
    echo "# Creation date: `date`"
    echo "#--------------------------------------------------------------------"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# color enable option"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "USE_COLORS" "Enable colors"
    printvar "MAP_CONSOLE_COLORS" "Map color pair 0 to console color"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# global cui application appearence options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "TITLE_BACKGROUND_COLOR" "Prog. title background color"
    printvar "TITLE_TEXT_COLOR" "Prog. title text color"
    printvar "STATUS_BACKGROUND_COLOR" "Status bar background color"
    printvar "STATUS_TEXT_COLOR" "Status bar text color"
    printvar "WINDOW_BACKGROUND" "Background color of main window"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# menu color options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "MENU_TEXT_NORMAL_COLOR" "Menu text color"
    printvar "MENU_TEXT_SELECTED_COLOR" "Menu selected text color"
    printvar "MENU_NUMBER_NORMAL_COLOR" "Number text color"
    printvar "MENU_NUMBER_SELECTED_COLOR" "Number selected text color"
    printvar "MENU_BACKGROUND_COLOR" "Menu background color"
    printvar "MENU_SELECTION_COLOR" "Menu selection color"
    printvar "MENU_FRAME_COLOR" "Menu frame color"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# text window view options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "TEXTWIN_TEXT_COLOR" "Text color of text window views"
    printvar "TEXTWIN_BACKGROUND_COLOR" "Background of text window views"
    printvar "TEXTWIN_FRAME_COLOR" "Frame color of text windows"
    printvar "TEXTWIN_TEXT_SELECTED_COLOR" "Text color of selected text"
    printvar "TEXTWIN_SELECTION_COLOR" "Background color of selected text"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# terminal window view options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "TERMWIN_TEXT_COLOR" "Terminal window text color"
    printvar "TERMWIN_BACKGROUND_COLOR" "Terminal window background"
    printvar "TERMWIN_FRAME_COLOR" "Terminal window frame color"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# list view options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "LISTWIN_TEXT_COLOR" "List view window text color"
    printvar "LISTWIN_TEXT_TITLE_COLOR" "List view title text color"
    printvar "LISTWIN_TEXT_SELECTED_COLOR" "List view selected text color"
    printvar "LISTWIN_SELECTION_COLOR" "List view selection color"
    printvar "LISTWIN_BACKGROUND_COLOR" "List view  background"
    printvar "LISTWIN_FRAME_COLOR" "List view  frame color"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# ECE help window view options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "HELPWIN_TEXT_COLOR" "ECE help window text color"
    printvar "HELPWIN_BACKGROUND_COLOR" "ECE help window background"
    printvar "HELPWIN_FRAME_COLOR" "ECE help window frame color"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# ECE config view options"
    echo "#--------------------------------------------------------------------"
    echo ""
    printvar "CONFIG_FRAME_COLOR" "ECE config window frame color"
    printvar "CONFIG_NAMES_COLOR" "ECE variable text color"
    printvar "CONFIG_TEXT_NORMAL_COLOR" "ECE config window text color"
    printvar "CONFIG_TEXT_SELECTED_COLOR" "ECE selected text color"
    printvar "CONFIG_SELECTION_COLOR" "ECE selection color"
    printvar "CONFIG_BACKGROUND_COLOR" "ECE config window background"
    echo ""
    printvar "CONFIG_SHOW_LINES" "ECE Show seperator lines"
    printvar "CONFIG_SHOW_COMMENTS" "ECE Show comments"
    echo ""
    echo "#--------------------------------------------------------------------"
    echo "# End"
    echo "#--------------------------------------------------------------------"
    echo ""
} > /etc/menu.conf
# Set rights
chmod 0644 /etc/menu.conf
chown root /etc/menu.conf

exit 0
